//
//  SecondViewController.m
//  PlayRecord
//
//  Created by Jeff Meininger on 10/1/12.
//  Copyright (c) 2012 Jeff Meininger. All rights reserved.
//

#import "SecondViewController.h"

@interface SecondViewController ()

@end

@implementation SecondViewController

@synthesize audioRecorder = _audioRecorder;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        self.title = NSLocalizedString(@"Second", @"Second");
        self.tabBarItem.image = [UIImage imageNamed:@"second"];
    }
    return self;
}
							
- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}


- (void)setupAudioSession
{
    AVAudioSession *session = [AVAudioSession sharedInstance];
    NSLog(@"setupAudioSession CATEGORY WAS: %@", session.category);
    if (![session setCategory:AVAudioSessionCategoryRecord error:nil]) {
        NSLog(@"**** SET CATEGORY failed");
        return;
    }
    NSLog(@"setupAudioSession CATEGORY IS : %@", session.category);
    
    if (!session.inputIsAvailable) {  // Can also target iOS6 and use inputAvailable... no difference.
        NSLog(@"**** inputIsAvailable failed");
        return;
    }
	if (![session setActive:YES error:nil]) {
        NSLog(@"**** setActive failed");
        return;
    }
}

- (NSURL*)nextAudioFileURL
{
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
	[formatter setDateFormat:@"ddMMMYY_hhmmssa"];
	NSString *name = [[formatter stringFromDate:[NSDate date]] stringByAppendingString:@".m4a"];
	
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *path = [[paths objectAtIndex:0] stringByAppendingPathComponent:name];
	
	return [NSURL fileURLWithPath:path];
}

- (IBAction)startRecording:(id)sender
{
    [self setupAudioSession];
    
	NSURL *url = [self nextAudioFileURL];
	
	NSMutableDictionary *settings = [NSMutableDictionary dictionary];
	[settings setValue: [NSNumber numberWithInt:kAudioFormatMPEG4AAC] forKey:AVFormatIDKey];
	[settings setValue: [NSNumber numberWithInt:AVAudioQualityLow] forKey: AVEncoderAudioQualityKey];
	[settings setValue: [NSNumber numberWithFloat:8000.0f] forKey:AVSampleRateKey];
	[settings setValue: [NSNumber numberWithInt: 1] forKey:AVNumberOfChannelsKey]; // mono
	
	BOOL okay = NO;
	
	self.audioRecorder = [[AVAudioRecorder alloc] initWithURL:url settings:settings error:nil];
	if (self.audioRecorder != nil) {
		self.audioRecorder.meteringEnabled = YES;
		okay = YES;
	}
	
	if (okay && ![self.audioRecorder prepareToRecord]) {
        NSLog(@"**** prepareToRecord failed");
		okay = NO;
	}
	
	if (okay && ![self.audioRecorder record]) {
        
        /*
         * THIS IS WHAT IS FAILING ON iPHONE4 with iOS6.  Why?
         */
        
        NSLog(@"**** record failed");
		okay = NO;
	}
	
	if (okay) {
        
        /*
         * You get here on most devices.
         */
        
		NSLog(@"HOORAY!!  THINGS WORKED!!!");
        
	} else {
        
        /*
         * You get here on iPhone4 with iOS6.
         */
        
        NSLog(@"Nope.  Things did not work.");
	}
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
